/* options-gsettings.c generated by valac 0.56.14, the Vala compiler
 * generated from options-gsettings.vala, do not modify */

/*
 * -*- Mode:Vala; indent-tabs-mode:t; tab-width:4; encoding:utf8 -*-
 * Copyright 2015 Canonical Ltd.
 * Copyright 2021-2022 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Charles Kerr <charles.kerr@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <ayatana/common/utils.h>
#include <float.h>
#include <math.h>
#include <pulse/pulseaudio.h>

#define INDICATOR_SOUND_OPTIONS_GSETTINGS_AMP_dB_KEY "amplified-volume-decibels"
#define INDICATOR_SOUND_OPTIONS_GSETTINGS_NORMAL_dB_KEY "normal-volume-decibels"
#define INDICATOR_SOUND_OPTIONS_GSETTINGS_ALLOW_AMP_KEY "allow-amplified-volume"
#define INDICATOR_SOUND_OPTIONS_GSETTINGS_LOUD_ENABLED_KEY "warning-volume-enabled"
#define INDICATOR_SOUND_OPTIONS_GSETTINGS_LOUD_DECIBEL_KEY "warning-volume-decibels"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define INDICATOR_SOUND_TYPE_OPTIONS (indicator_sound_options_get_type ())
#define INDICATOR_SOUND_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptions))
#define INDICATOR_SOUND_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptionsClass))
#define INDICATOR_SOUND_IS_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_OPTIONS))
#define INDICATOR_SOUND_IS_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_OPTIONS))
#define INDICATOR_SOUND_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptionsClass))

typedef struct _IndicatorSoundOptions IndicatorSoundOptions;
typedef struct _IndicatorSoundOptionsClass IndicatorSoundOptionsClass;
typedef struct _IndicatorSoundOptionsPrivate IndicatorSoundOptionsPrivate;

#define INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS (indicator_sound_options_gsettings_get_type ())
#define INDICATOR_SOUND_OPTIONS_GSETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS, IndicatorSoundOptionsGSettings))
#define INDICATOR_SOUND_OPTIONS_GSETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS, IndicatorSoundOptionsGSettingsClass))
#define INDICATOR_SOUND_IS_OPTIONS_GSETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS))
#define INDICATOR_SOUND_IS_OPTIONS_GSETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS))
#define INDICATOR_SOUND_OPTIONS_GSETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS, IndicatorSoundOptionsGSettingsClass))

typedef struct _IndicatorSoundOptionsGSettings IndicatorSoundOptionsGSettings;
typedef struct _IndicatorSoundOptionsGSettingsClass IndicatorSoundOptionsGSettingsClass;
typedef struct _IndicatorSoundOptionsGSettingsPrivate IndicatorSoundOptionsGSettingsPrivate;
enum  {
	INDICATOR_SOUND_OPTIONS_GSETTINGS_0_PROPERTY,
	INDICATOR_SOUND_OPTIONS_GSETTINGS_NUM_PROPERTIES
};
static GParamSpec* indicator_sound_options_gsettings_properties[INDICATOR_SOUND_OPTIONS_GSETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _IndicatorSoundOptions {
	GObject parent_instance;
	IndicatorSoundOptionsPrivate * priv;
};

struct _IndicatorSoundOptionsClass {
	GObjectClass parent_class;
};

struct _IndicatorSoundOptionsGSettings {
	IndicatorSoundOptions parent_instance;
	IndicatorSoundOptionsGSettingsPrivate * priv;
};

struct _IndicatorSoundOptionsGSettingsClass {
	IndicatorSoundOptionsClass parent_class;
};

struct _IndicatorSoundOptionsGSettingsPrivate {
	GSettings* _settings;
	GSettings* _shared_settings;
};

static gint IndicatorSoundOptionsGSettings_private_offset;
static gpointer indicator_sound_options_gsettings_parent_class = NULL;

VALA_EXTERN GType indicator_sound_options_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundOptions, g_object_unref)
VALA_EXTERN GType indicator_sound_options_gsettings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundOptionsGSettings, g_object_unref)
VALA_EXTERN IndicatorSoundOptionsGSettings* indicator_sound_options_gsettings_new (void);
VALA_EXTERN IndicatorSoundOptionsGSettings* indicator_sound_options_gsettings_construct (GType object_type);
VALA_EXTERN IndicatorSoundOptions* indicator_sound_options_construct (GType object_type);
static void indicator_sound_options_gsettings_init_max_volume (IndicatorSoundOptionsGSettings* self);
static void indicator_sound_options_gsettings_init_loud_volume (IndicatorSoundOptionsGSettings* self);
static void __lambda4_ (IndicatorSoundOptionsGSettings* self);
static void indicator_sound_options_gsettings_update_max_volume (IndicatorSoundOptionsGSettings* self);
static void ___lambda4__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda5_ (IndicatorSoundOptionsGSettings* self);
static void ___lambda5__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void ___lambda6_ (IndicatorSoundOptionsGSettings* self);
static void ____lambda6__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
VALA_EXTERN void indicator_sound_options_gsettings_set_max_volume_ (IndicatorSoundOptionsGSettings* self,
                                                        gdouble vol);
static gdouble indicator_sound_options_gsettings_calculate_max_volume (IndicatorSoundOptionsGSettings* self);
VALA_EXTERN gdouble indicator_sound_options_get_max_volume (IndicatorSoundOptions* self);
VALA_EXTERN void indicator_sound_options_set_max_volume (IndicatorSoundOptions* self,
                                             gdouble value);
VALA_EXTERN gdouble volume_control_pulse_volume_to_double (pa_volume_t vol);
static void __lambda7_ (IndicatorSoundOptionsGSettings* self);
static void indicator_sound_options_gsettings_update_loud_volume (IndicatorSoundOptionsGSettings* self);
static void ___lambda7__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda8_ (IndicatorSoundOptionsGSettings* self);
static void ___lambda8__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
VALA_EXTERN guint indicator_sound_options_get_loud_volume (IndicatorSoundOptions* self);
VALA_EXTERN void indicator_sound_options_set_loud_volume (IndicatorSoundOptions* self,
                                              guint value);
VALA_EXTERN gboolean indicator_sound_options_get_loud_warning_enabled (IndicatorSoundOptions* self);
VALA_EXTERN void indicator_sound_options_set_loud_warning_enabled (IndicatorSoundOptions* self,
                                                       gboolean value);
static void indicator_sound_options_gsettings_finalize (GObject * obj);
static GType indicator_sound_options_gsettings_get_type_once (void);

static inline gpointer
indicator_sound_options_gsettings_get_instance_private (IndicatorSoundOptionsGSettings* self)
{
	return G_STRUCT_MEMBER_P (self, IndicatorSoundOptionsGSettings_private_offset);
}

IndicatorSoundOptionsGSettings*
indicator_sound_options_gsettings_construct (GType object_type)
{
	IndicatorSoundOptionsGSettings * self = NULL;
	self = (IndicatorSoundOptionsGSettings*) indicator_sound_options_construct (object_type);
	indicator_sound_options_gsettings_init_max_volume (self);
	indicator_sound_options_gsettings_init_loud_volume (self);
	return self;
}

IndicatorSoundOptionsGSettings*
indicator_sound_options_gsettings_new (void)
{
	return indicator_sound_options_gsettings_construct (INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS);
}

static void
__lambda4_ (IndicatorSoundOptionsGSettings* self)
{
	indicator_sound_options_gsettings_update_max_volume (self);
}

static void
___lambda4__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
	__lambda4_ ((IndicatorSoundOptionsGSettings*) self);
}

static void
__lambda5_ (IndicatorSoundOptionsGSettings* self)
{
	indicator_sound_options_gsettings_update_max_volume (self);
}

static void
___lambda5__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
	__lambda5_ ((IndicatorSoundOptionsGSettings*) self);
}

static void
___lambda6_ (IndicatorSoundOptionsGSettings* self)
{
	indicator_sound_options_gsettings_update_max_volume (self);
}

static void
____lambda6__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
	___lambda6_ ((IndicatorSoundOptionsGSettings*) self);
}

static void
indicator_sound_options_gsettings_init_max_volume (IndicatorSoundOptionsGSettings* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_strconcat ("changed::", INDICATOR_SOUND_OPTIONS_GSETTINGS_NORMAL_dB_KEY, NULL);
	g_signal_connect_object (_tmp0_, _tmp1_, (GCallback) ___lambda4__g_settings_changed, self, 0);
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_settings;
	_tmp3_ = g_strconcat ("changed::", INDICATOR_SOUND_OPTIONS_GSETTINGS_AMP_dB_KEY, NULL);
	g_signal_connect_object (_tmp2_, _tmp3_, (GCallback) ___lambda5__g_settings_changed, self, 0);
	_g_free0 (_tmp3_);
	if (ayatana_common_utils_is_lomiri ()) {
		GSettings* _tmp4_;
		GSettings* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = g_settings_new ("com.lomiri.sound");
		_g_object_unref0 (self->priv->_shared_settings);
		self->priv->_shared_settings = _tmp4_;
		_tmp5_ = self->priv->_shared_settings;
		_tmp6_ = g_strconcat ("changed::", INDICATOR_SOUND_OPTIONS_GSETTINGS_ALLOW_AMP_KEY, NULL);
		g_signal_connect_object (_tmp5_, _tmp6_, (GCallback) ____lambda6__g_settings_changed, self, 0);
		_g_free0 (_tmp6_);
	}
	indicator_sound_options_gsettings_update_max_volume (self);
}

static void
indicator_sound_options_gsettings_update_max_volume (IndicatorSoundOptionsGSettings* self)
{
	g_return_if_fail (self != NULL);
	indicator_sound_options_gsettings_set_max_volume_ (self, indicator_sound_options_gsettings_calculate_max_volume (self));
}

void
indicator_sound_options_gsettings_set_max_volume_ (IndicatorSoundOptionsGSettings* self,
                                                   gdouble vol)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = indicator_sound_options_get_max_volume ((IndicatorSoundOptions*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != vol) {
		gdouble _tmp2_;
		gdouble _tmp3_;
		_tmp2_ = indicator_sound_options_get_max_volume ((IndicatorSoundOptions*) self);
		_tmp3_ = _tmp2_;
		g_debug ("options-gsettings.vala:62: changing max_volume from %f to %f", _tmp3_, vol);
		indicator_sound_options_set_max_volume ((IndicatorSoundOptions*) self, vol);
	}
}

static gdouble
indicator_sound_options_gsettings_calculate_max_volume (IndicatorSoundOptionsGSettings* self)
{
	const gchar* decibel_key = NULL;
	gdouble volume_dB = 0.0;
	GSettings* _tmp2_;
	const gchar* _tmp3_;
	pa_volume_t volume_sw = 0U;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	decibel_key = INDICATOR_SOUND_OPTIONS_GSETTINGS_NORMAL_dB_KEY;
	if (ayatana_common_utils_is_lomiri ()) {
		const gchar* _tmp0_ = NULL;
		GSettings* _tmp1_;
		_tmp1_ = self->priv->_shared_settings;
		if (g_settings_get_boolean (_tmp1_, INDICATOR_SOUND_OPTIONS_GSETTINGS_ALLOW_AMP_KEY)) {
			_tmp0_ = INDICATOR_SOUND_OPTIONS_GSETTINGS_AMP_dB_KEY;
		} else {
			_tmp0_ = INDICATOR_SOUND_OPTIONS_GSETTINGS_NORMAL_dB_KEY;
		}
		decibel_key = _tmp0_;
	}
	_tmp2_ = self->priv->_settings;
	_tmp3_ = decibel_key;
	volume_dB = g_settings_get_double (_tmp2_, _tmp3_);
	volume_sw = pa_sw_volume_from_dB (volume_dB);
	result = volume_control_pulse_volume_to_double (volume_sw);
	return result;
}

static void
__lambda7_ (IndicatorSoundOptionsGSettings* self)
{
	indicator_sound_options_gsettings_update_loud_volume (self);
}

static void
___lambda7__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
	__lambda7_ ((IndicatorSoundOptionsGSettings*) self);
}

static void
__lambda8_ (IndicatorSoundOptionsGSettings* self)
{
	indicator_sound_options_gsettings_update_loud_volume (self);
}

static void
___lambda8__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
	__lambda8_ ((IndicatorSoundOptionsGSettings*) self);
}

static void
indicator_sound_options_gsettings_init_loud_volume (IndicatorSoundOptionsGSettings* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_strconcat ("changed::", INDICATOR_SOUND_OPTIONS_GSETTINGS_LOUD_ENABLED_KEY, NULL);
	g_signal_connect_object (_tmp0_, _tmp1_, (GCallback) ___lambda7__g_settings_changed, self, 0);
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_settings;
	_tmp3_ = g_strconcat ("changed::", INDICATOR_SOUND_OPTIONS_GSETTINGS_LOUD_DECIBEL_KEY, NULL);
	g_signal_connect_object (_tmp2_, _tmp3_, (GCallback) ___lambda8__g_settings_changed, self, 0);
	_g_free0 (_tmp3_);
	indicator_sound_options_gsettings_update_loud_volume (self);
}

static void
indicator_sound_options_gsettings_update_loud_volume (IndicatorSoundOptionsGSettings* self)
{
	pa_volume_t vol = 0U;
	GSettings* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	gboolean enabled = FALSE;
	GSettings* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_settings;
	vol = pa_sw_volume_from_dB (g_settings_get_double (_tmp0_, INDICATOR_SOUND_OPTIONS_GSETTINGS_LOUD_DECIBEL_KEY));
	_tmp1_ = indicator_sound_options_get_loud_volume ((IndicatorSoundOptions*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != ((guint) vol)) {
		indicator_sound_options_set_loud_volume ((IndicatorSoundOptions*) self, (guint) vol);
	}
	_tmp3_ = self->priv->_settings;
	enabled = g_settings_get_boolean (_tmp3_, INDICATOR_SOUND_OPTIONS_GSETTINGS_LOUD_ENABLED_KEY);
	_tmp4_ = indicator_sound_options_get_loud_warning_enabled ((IndicatorSoundOptions*) self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != enabled) {
		indicator_sound_options_set_loud_warning_enabled ((IndicatorSoundOptions*) self, enabled);
	}
}

static void
indicator_sound_options_gsettings_class_init (IndicatorSoundOptionsGSettingsClass * klass,
                                              gpointer klass_data)
{
	indicator_sound_options_gsettings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IndicatorSoundOptionsGSettings_private_offset);
	G_OBJECT_CLASS (klass)->finalize = indicator_sound_options_gsettings_finalize;
}

static void
indicator_sound_options_gsettings_instance_init (IndicatorSoundOptionsGSettings * self,
                                                 gpointer klass)
{
	GSettings* _tmp0_;
	self->priv = indicator_sound_options_gsettings_get_instance_private (self);
	_tmp0_ = g_settings_new ("org.ayatana.indicator.sound");
	self->priv->_settings = _tmp0_;
	self->priv->_shared_settings = NULL;
}

static void
indicator_sound_options_gsettings_finalize (GObject * obj)
{
	IndicatorSoundOptionsGSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, INDICATOR_SOUND_TYPE_OPTIONS_GSETTINGS, IndicatorSoundOptionsGSettings);
	_g_object_unref0 (self->priv->_settings);
	_g_object_unref0 (self->priv->_shared_settings);
	G_OBJECT_CLASS (indicator_sound_options_gsettings_parent_class)->finalize (obj);
}

static GType
indicator_sound_options_gsettings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorSoundOptionsGSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_sound_options_gsettings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorSoundOptionsGSettings), 0, (GInstanceInitFunc) indicator_sound_options_gsettings_instance_init, NULL };
	GType indicator_sound_options_gsettings_type_id;
	indicator_sound_options_gsettings_type_id = g_type_register_static (INDICATOR_SOUND_TYPE_OPTIONS, "IndicatorSoundOptionsGSettings", &g_define_type_info, 0);
	IndicatorSoundOptionsGSettings_private_offset = g_type_add_instance_private (indicator_sound_options_gsettings_type_id, sizeof (IndicatorSoundOptionsGSettingsPrivate));
	return indicator_sound_options_gsettings_type_id;
}

GType
indicator_sound_options_gsettings_get_type (void)
{
	static volatile gsize indicator_sound_options_gsettings_type_id__once = 0;
	if (g_once_init_enter (&indicator_sound_options_gsettings_type_id__once)) {
		GType indicator_sound_options_gsettings_type_id;
		indicator_sound_options_gsettings_type_id = indicator_sound_options_gsettings_get_type_once ();
		g_once_init_leave (&indicator_sound_options_gsettings_type_id__once, indicator_sound_options_gsettings_type_id);
	}
	return indicator_sound_options_gsettings_type_id__once;
}

