/* warn-notification.c generated by valac 0.56.14, the Vala compiler
 * generated from warn-notification.vala, do not modify */

/*
 * Copyright 2015 Canonical Ltd.
 * Copyright 2021-2023 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Charles Kerr <charles.kerr@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <libnotify/notify.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define INDICATOR_SOUND_TYPE_NOTIFICATION (indicator_sound_notification_get_type ())
#define INDICATOR_SOUND_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotification))
#define INDICATOR_SOUND_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotificationClass))
#define INDICATOR_SOUND_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION))
#define INDICATOR_SOUND_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_NOTIFICATION))
#define INDICATOR_SOUND_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotificationClass))

typedef struct _IndicatorSoundNotification IndicatorSoundNotification;
typedef struct _IndicatorSoundNotificationClass IndicatorSoundNotificationClass;
typedef struct _IndicatorSoundNotificationPrivate IndicatorSoundNotificationPrivate;

#define INDICATOR_SOUND_TYPE_WARN_NOTIFICATION (indicator_sound_warn_notification_get_type ())
#define INDICATOR_SOUND_WARN_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_WARN_NOTIFICATION, IndicatorSoundWarnNotification))
#define INDICATOR_SOUND_WARN_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_WARN_NOTIFICATION, IndicatorSoundWarnNotificationClass))
#define INDICATOR_SOUND_IS_WARN_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_WARN_NOTIFICATION))
#define INDICATOR_SOUND_IS_WARN_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_WARN_NOTIFICATION))
#define INDICATOR_SOUND_WARN_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_WARN_NOTIFICATION, IndicatorSoundWarnNotificationClass))

typedef struct _IndicatorSoundWarnNotification IndicatorSoundWarnNotification;
typedef struct _IndicatorSoundWarnNotificationClass IndicatorSoundWarnNotificationClass;
typedef struct _IndicatorSoundWarnNotificationPrivate IndicatorSoundWarnNotificationPrivate;
enum  {
	INDICATOR_SOUND_WARN_NOTIFICATION_0_PROPERTY,
	INDICATOR_SOUND_WARN_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* indicator_sound_warn_notification_properties[INDICATOR_SOUND_WARN_NOTIFICATION_NUM_PROPERTIES];
typedef enum  {
	INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_CANCEL,
	INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_OK
} IndicatorSoundWarnNotificationResponse;

#define INDICATOR_SOUND_WARN_NOTIFICATION_TYPE_RESPONSE (indicator_sound_warn_notification_response_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	INDICATOR_SOUND_WARN_NOTIFICATION_USER_RESPONDED_SIGNAL,
	INDICATOR_SOUND_WARN_NOTIFICATION_NUM_SIGNALS
};
static guint indicator_sound_warn_notification_signals[INDICATOR_SOUND_WARN_NOTIFICATION_NUM_SIGNALS] = {0};

struct _IndicatorSoundNotification {
	GObject parent_instance;
	IndicatorSoundNotificationPrivate * priv;
	NotifyNotification* _notification;
};

struct _IndicatorSoundNotificationClass {
	GObjectClass parent_class;
	NotifyNotification* (*create_notification) (IndicatorSoundNotification* self);
};

struct _IndicatorSoundWarnNotification {
	IndicatorSoundNotification parent_instance;
	IndicatorSoundWarnNotificationPrivate * priv;
};

struct _IndicatorSoundWarnNotificationClass {
	IndicatorSoundNotificationClass parent_class;
};

static gpointer indicator_sound_warn_notification_parent_class = NULL;

VALA_EXTERN GType indicator_sound_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundNotification, g_object_unref)
VALA_EXTERN GType indicator_sound_warn_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundWarnNotification, g_object_unref)
VALA_EXTERN NotifyNotification* indicator_sound_notification_create_notification (IndicatorSoundNotification* self);
VALA_EXTERN GType indicator_sound_warn_notification_response_get_type (void) G_GNUC_CONST ;
static NotifyNotification* indicator_sound_warn_notification_real_create_notification (IndicatorSoundNotification* base);
static GVariant* _variant_new1 (const gchar* value);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (const gchar* value);
static void __lambda4_ (IndicatorSoundWarnNotification* self,
                 NotifyNotification* n);
static void ___lambda4__notify_notification_closed (NotifyNotification* _sender,
                                             gpointer self);
VALA_EXTERN gboolean indicator_sound_warn_notification_show (IndicatorSoundWarnNotification* self);
VALA_EXTERN gboolean indicator_sound_notification_notify_server_supports (IndicatorSoundNotification* self,
                                                              const gchar* cap);
static void __lambda5_ (IndicatorSoundWarnNotification* self,
                 NotifyNotification* n,
                 const gchar* a);
static void ___lambda5__notify_action_callback (NotifyNotification* notification,
                                         const gchar* action,
                                         gpointer self);
static void __lambda6_ (IndicatorSoundWarnNotification* self,
                 NotifyNotification* n,
                 const gchar* a);
static void ___lambda6__notify_action_callback (NotifyNotification* notification,
                                         const gchar* action,
                                         gpointer self);
VALA_EXTERN void indicator_sound_notification_show_notification (IndicatorSoundNotification* self);
VALA_EXTERN IndicatorSoundWarnNotification* indicator_sound_warn_notification_new (void);
VALA_EXTERN IndicatorSoundWarnNotification* indicator_sound_warn_notification_construct (GType object_type);
VALA_EXTERN IndicatorSoundNotification* indicator_sound_notification_construct (GType object_type);
static GType indicator_sound_warn_notification_get_type_once (void);

static GType
indicator_sound_warn_notification_response_get_type_once (void)
{
	static const GEnumValue values[] = {{INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_CANCEL, "INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_CANCEL", "cancel"}, {INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_OK, "INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_OK", "ok"}, {0, NULL, NULL}};
	GType indicator_sound_warn_notification_response_type_id;
	indicator_sound_warn_notification_response_type_id = g_enum_register_static ("IndicatorSoundWarnNotificationResponse", values);
	return indicator_sound_warn_notification_response_type_id;
}

GType
indicator_sound_warn_notification_response_get_type (void)
{
	static volatile gsize indicator_sound_warn_notification_response_type_id__once = 0;
	if (g_once_init_enter (&indicator_sound_warn_notification_response_type_id__once)) {
		GType indicator_sound_warn_notification_response_type_id;
		indicator_sound_warn_notification_response_type_id = indicator_sound_warn_notification_response_get_type_once ();
		g_once_init_leave (&indicator_sound_warn_notification_response_type_id__once, indicator_sound_warn_notification_response_type_id);
	}
	return indicator_sound_warn_notification_response_type_id__once;
}

static GVariant*
_variant_new1 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new2 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new3 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static void
__lambda4_ (IndicatorSoundWarnNotification* self,
            NotifyNotification* n)
{
	g_return_if_fail (n != NULL);
	notify_notification_clear_actions (n);
}

static void
___lambda4__notify_notification_closed (NotifyNotification* _sender,
                                        gpointer self)
{
	__lambda4_ ((IndicatorSoundWarnNotification*) self, _sender);
}

static NotifyNotification*
indicator_sound_warn_notification_real_create_notification (IndicatorSoundNotification* base)
{
	IndicatorSoundWarnNotification * self;
	NotifyNotification* n = NULL;
	NotifyNotification* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	NotifyNotification* result;
	self = (IndicatorSoundWarnNotification*) base;
	_tmp0_ = notify_notification_new (_ ("Volume"), _ ("Allow volume above safe level?\nHigh volume can damage your hearing."), "audio-volume-high");
	n = _tmp0_;
	_tmp1_ = _variant_new1 ("true");
	notify_notification_set_hint (n, "x-lomiri-non-shaped-icon", _tmp1_);
	_g_variant_unref0 (_tmp1_);
	_tmp2_ = _variant_new2 ("true");
	notify_notification_set_hint (n, "x-lomiri-snap-decisions", _tmp2_);
	_g_variant_unref0 (_tmp2_);
	_tmp3_ = _variant_new3 ("true");
	notify_notification_set_hint (n, "x-lomiri-private-affirmative-tint", _tmp3_);
	_g_variant_unref0 (_tmp3_);
	g_signal_connect_object (n, "closed", (GCallback) ___lambda4__notify_notification_closed, self, 0);
	result = n;
	return result;
}

static void
__lambda5_ (IndicatorSoundWarnNotification* self,
            NotifyNotification* n,
            const gchar* a)
{
	g_return_if_fail (n != NULL);
	g_return_if_fail (a != NULL);
	g_signal_emit (self, indicator_sound_warn_notification_signals[INDICATOR_SOUND_WARN_NOTIFICATION_USER_RESPONDED_SIGNAL], 0, INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_OK);
}

static void
___lambda5__notify_action_callback (NotifyNotification* notification,
                                    const gchar* action,
                                    gpointer self)
{
	__lambda5_ ((IndicatorSoundWarnNotification*) self, notification, action);
}

static void
__lambda6_ (IndicatorSoundWarnNotification* self,
            NotifyNotification* n,
            const gchar* a)
{
	g_return_if_fail (n != NULL);
	g_return_if_fail (a != NULL);
	g_signal_emit (self, indicator_sound_warn_notification_signals[INDICATOR_SOUND_WARN_NOTIFICATION_USER_RESPONDED_SIGNAL], 0, INDICATOR_SOUND_WARN_NOTIFICATION_RESPONSE_CANCEL);
}

static void
___lambda6__notify_action_callback (NotifyNotification* notification,
                                    const gchar* action,
                                    gpointer self)
{
	__lambda6_ ((IndicatorSoundWarnNotification*) self, notification, action);
}

gboolean
indicator_sound_warn_notification_show (IndicatorSoundWarnNotification* self)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp1_;
	NotifyNotification* _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!indicator_sound_notification_notify_server_supports ((IndicatorSoundNotification*) self, "actions")) {
		result = FALSE;
		return result;
	}
	_tmp0_ = ((IndicatorSoundNotification*) self)->_notification;
	notify_notification_clear_actions (_tmp0_);
	_tmp1_ = ((IndicatorSoundNotification*) self)->_notification;
	notify_notification_add_action (_tmp1_, "ok", _ ("OK"), ___lambda5__notify_action_callback, g_object_ref (self), g_object_unref);
	_tmp2_ = ((IndicatorSoundNotification*) self)->_notification;
	notify_notification_add_action (_tmp2_, "cancel", _ ("Cancel"), ___lambda6__notify_action_callback, g_object_ref (self), g_object_unref);
	indicator_sound_notification_show_notification ((IndicatorSoundNotification*) self);
	result = TRUE;
	return result;
}

IndicatorSoundWarnNotification*
indicator_sound_warn_notification_construct (GType object_type)
{
	IndicatorSoundWarnNotification * self = NULL;
	self = (IndicatorSoundWarnNotification*) indicator_sound_notification_construct (object_type);
	return self;
}

IndicatorSoundWarnNotification*
indicator_sound_warn_notification_new (void)
{
	return indicator_sound_warn_notification_construct (INDICATOR_SOUND_TYPE_WARN_NOTIFICATION);
}

static void
indicator_sound_warn_notification_class_init (IndicatorSoundWarnNotificationClass * klass,
                                              gpointer klass_data)
{
	indicator_sound_warn_notification_parent_class = g_type_class_peek_parent (klass);
	((IndicatorSoundNotificationClass *) klass)->create_notification = (NotifyNotification* (*) (IndicatorSoundNotification*)) indicator_sound_warn_notification_real_create_notification;
	indicator_sound_warn_notification_signals[INDICATOR_SOUND_WARN_NOTIFICATION_USER_RESPONDED_SIGNAL] = g_signal_new ("user-responded", INDICATOR_SOUND_TYPE_WARN_NOTIFICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, INDICATOR_SOUND_WARN_NOTIFICATION_TYPE_RESPONSE);
}

static void
indicator_sound_warn_notification_instance_init (IndicatorSoundWarnNotification * self,
                                                 gpointer klass)
{
}

static GType
indicator_sound_warn_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorSoundWarnNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_sound_warn_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorSoundWarnNotification), 0, (GInstanceInitFunc) indicator_sound_warn_notification_instance_init, NULL };
	GType indicator_sound_warn_notification_type_id;
	indicator_sound_warn_notification_type_id = g_type_register_static (INDICATOR_SOUND_TYPE_NOTIFICATION, "IndicatorSoundWarnNotification", &g_define_type_info, 0);
	return indicator_sound_warn_notification_type_id;
}

GType
indicator_sound_warn_notification_get_type (void)
{
	static volatile gsize indicator_sound_warn_notification_type_id__once = 0;
	if (g_once_init_enter (&indicator_sound_warn_notification_type_id__once)) {
		GType indicator_sound_warn_notification_type_id;
		indicator_sound_warn_notification_type_id = indicator_sound_warn_notification_get_type_once ();
		g_once_init_leave (&indicator_sound_warn_notification_type_id__once, indicator_sound_warn_notification_type_id);
	}
	return indicator_sound_warn_notification_type_id__once;
}

